#include <stdint.h>
#include <fcitx/fcitx.h>
#include <fcitx-utils/utils.h>
#include <fcitx/instance.h>
#include <fcitx/addon.h>
#include <fcitx/module.h>


#ifndef __FCITX_MODULE_FCITX_LUA_ADD_FUNCTION_H
#define __FCITX_MODULE_FCITX_LUA_ADD_FUNCTION_H

#ifdef __cplusplus
extern "C" {
#endif

DEFINE_GET_ADDON("fcitx-lua", _Lua_)

static void*
__fcitx_Lua_function_CallCommand(void *_self, FcitxModuleFunctionArg _args)
{
    FCITX_DEF_CAST_FROM_PTR(LuaModule*, __self, _self);
    FCITX_DEF_CAST_FROM_PTR(const char*, arg0, _args.args[0]);
    FCITX_DEF_CAST_FROM_PTR(FcitxCandidateWordCommitCallback, arg1, _args.args[1]);
    FCITX_DEF_CAST_FROM_PTR(void*, arg2, _args.args[2]);
    LuaModule* self = __self;
    FCITX_UNUSED(self);
    LuaCallCommand(self, arg0, arg1, arg2);
    return NULL;
}

static void
FcitxLuaAddFunctions(FcitxInstance *instance)
{
    int i;
    FcitxAddon *addon = Fcitx_Lua_GetAddon(instance);
    static const FcitxModuleFunction ____fcitx_Lua_addon_functions_table[] = {
        __fcitx_Lua_function_CallCommand,
    };
    for (i = 0;i < 1;i++) {
        FcitxModuleAddFunction(addon, ____fcitx_Lua_addon_functions_table[i]);
    }
}

#ifdef __cplusplus
}
#endif

#endif
